// based on deformableRegistration2.cxx from itk examples

#if defined(_MSC_VER)
#pragma warning ( disable : 4786 )
#endif


#include "itkImageFileReader.h" 
#include "itkImageFileWriter.h" 

#include "itkImageRegionIterator.h"

#include "itkHistogramMatchingImageFilter.h"
#include "itkCastImageFilter.h"
#include "itkWarpImageFilter.h"
#include "itkLinearInterpolateImageFunction.h"

#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"
#include "itkRescaleIntensityImageFilter.h"


// includes propis
#include "./src/definicionsTipus.h"
#include "./src/funcionsAuxiliars.cxx"


#include "itkImage.h"

int main( int argc, char *argv[] )
{
  if( argc < 4 )
    {
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " fixedImageFile movingImageFile ";
    std::cerr << " outputImageFile " << std::endl;
    return EXIT_FAILURE;
    }

  // Set up the file readers
  FixedImageReaderType::Pointer fixedImageReader   = FixedImageReaderType::New();
  MovingImageReaderType::Pointer movingImageReader = MovingImageReaderType::New();

  fixedImageReader->SetFileName(  argv[1] );
  movingImageReader->SetFileName( argv[2] );
 
 // IdentityTransformType::Pointer identity = IdentityTransformType::New();

 // ResampleFilterType::Pointer resampler = ResampleFilterType::New();
  DifferenceFilterType::Pointer difference = DifferenceFilterType::New();
  WriterType::Pointer writer2 = WriterType::New();

  //resampler->SetInput( movingImageReader->GetOutput() );

  FixedImageType::Pointer fixedImage = fixedImageReader->GetOutput();

/*  resampler->SetSize(    fixedImage->GetLargestPossibleRegion().GetSize() );
  resampler->SetOutputOrigin(  fixedImage->GetOrigin() );
  resampler->SetOutputSpacing( fixedImage->GetSpacing() );
  resampler->SetOutputDirection( fixedImage->GetDirection() );
  resampler->SetDefaultPixelValue( 0 );
  resampler->SetTransform( identity );*/


  difference->SetInput1( fixedImageReader->GetOutput() );
  difference->SetInput2( movingImageReader->GetOutput() );
 // difference->SetInput2( resampler->GetOutput() );

  
  //OJU!! ELIMINEM EL REESCALAT!!!!
/*  RescalerType::Pointer intensityRescaler = RescalerType::New();

  intensityRescaler->SetInput( difference->GetOutput() );
  intensityRescaler->SetOutputMinimum( 0 );
  intensityRescaler->SetOutputMaximum( 255 );
  
  writer2->SetInput( intensityRescaler->GetOutput() );  */

 writer2->SetInput( difference->GetOutput() );  

//  resampler->SetDefaultPixelValue( 1 );

  writer2->SetFileName( argv[3]);
  writer2->Update();

  
  return EXIT_SUCCESS;
}

