// tots els includes necessaris per totes les aplicacions (registre rigid, registre flexible, registre rigid amb multiresolucio)

#if defined(_MSC_VER)
#pragma warning ( disable : 4786 )
#endif

#include "itkImageRegistrationMethod.h"
#include "itkMeanSquaresImageToImageMetric.h"
#include "itkMattesMutualInformationImageToImageMetric.h"
#include <itkMutualInformationImageToImageMetric.h>

#include "itkCenteredTransformInitializer.h"
#include "itkAffineTransform.h"

#include "itkTranslationTransform.h"

#include "itkCenteredRigid2DTransform.h"

#include "itkLinearInterpolateImageFunction.h"
#include "itkNearestNeighborInterpolateImageFunction.h"

#include "itkGDCMImageIO.h"
#include "itkImage.h"
#include "itkCommand.h"
#include <ctime>


#include "itkTimeProbesCollectorBase.h"

#ifdef ITK_USE_REVIEW
#include "itkMemoryProbesCollectorBase.h"
#define itkProbesCreate()  \
  itk::TimeProbesCollectorBase chronometer; \
  itk::MemoryProbesCollectorBase memorymeter
#define itkProbesStart( text ) memorymeter.Start( text ); chronometer.Start( text )
#define itkProbesStop( text )  chronometer.Stop( text ); memorymeter.Stop( text  )
#define itkProbesReport( stream )  chronometer.Report( stream ); memorymeter.Report( stream  )
#else
#define itkProbesCreate()  \
  itk::TimeProbesCollectorBase chronometer
#define itkProbesStart( text ) chronometer.Start( text )
#define itkProbesStop( text )  chronometer.Stop( text )
#define itkProbesReport( stream )  chronometer.Report( stream )
#endif

#include "itkBSplineDeformableTransform.h"
#include "itkRegularStepGradientDescentOptimizer.h"

#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"

#include "itkResampleImageFilter.h"
#include "itkCastImageFilter.h"
#include "itkSubtractImageFilter.h"
#include <itkAbsoluteValueDifferenceImageFilter.h>
#include "itkRescaleIntensityImageFilter.h"
#include "itkSquaredDifferenceImageFilter.h"
#include "itkCheckerBoardImageFilter.h"


// includes mariano
#include <itkImageRegistrationMethod.h>
#include <itkMultiResolutionImageRegistrationMethod.h>

#include <itkVersorRigid3DTransform.h>
#include <itkAffineTransform.h>
#include <itkBSplineDeformableTransform.h>
#include <itkCenteredTransformInitializer.h>
#include <itkScaleTransform.h>
#include <itkDemonsRegistrationFilter.h>


#include <itkRegularStepGradientDescentOptimizer.h>
#include <itkVersorRigid3DTransformOptimizer.h>

#include <itkLinearInterpolateImageFunction.h>
#include <itkNearestNeighborInterpolateImageFunction.h>
#include <itkBSplineInterpolateImageFunction.h>

#include <itkMutualInformationImageToImageMetric.h>
#include <itkMattesMutualInformationImageToImageMetric.h>
#include <itkMutualInformationHistogramImageToImageMetric.h>
#include <itkNormalizedMutualInformationHistogramImageToImageMetric.h>
#include <itkGradientDifferenceImageToImageMetric.h>
#include <itkKullbackLeiblerCompareHistogramImageToImageMetric.h>
#include <itkKappaStatisticImageToImageMetric.h>
#include <itkCorrelationCoefficientHistogramImageToImageMetric.h>
#include <itkNormalizedCorrelationImageToImageMetric.h>
#include <itkMeanSquaresImageToImageMetric.h>
#include <itkMeanSquaresHistogramImageToImageMetric.h>
#include <itkMeanReciprocalSquareDifferenceImageToImageMetric.h>

#include <itkBSplineResampleImageFunction.h>
#include <itkBSplineDecompositionImageFilter.h>
#include <itkResampleImageFilter.h>
#include <itkMultiResolutionPyramidImageFilter.h>
#include <itkHistogramMatchingImageFilter.h>

#include <itkCastImageFilter.h>
#include <itkRecursiveGaussianImageFilter.h>
#include <itkMinimumMaximumImageCalculator.h>

#include "../imagedefinitions.h"
#include "../registrationlevelupdate.h"


using namespace std;




// definicions de tipus abans a brainregistration.h
    typedef double CoordinateRepType;

    // Registration methods
    typedef itk::ImageRegistrationMethod<SignedImageType,SignedImageType > mRegistrationType;
    typedef itk::MultiResolutionImageRegistrationMethod<SignedImageType,SignedImageType > MultiResolutionRegistrationType;

    // Resamplers
    typedef itk::ResampleImageFilter<
            ProbabilityImageType,
            ProbabilityImageType > ResampleImageFilterType;
    typedef itk::ResampleImageFilter<SignedImageType, SignedImageType > ResampleSignedImageFilterType;
    typedef itk::ResampleImageFilter<
            ProbabilityImageType,
            ProbabilityImageType > ResampleAtlasFilterType;
    typedef itk::ResampleImageFilter<
            MaskImageType,
            MaskImageType > ResampleMaskFilterType;
    typedef itk::ResampleImageFilter<
            ResultsImageType,
            ResultsImageType > ResampleResultsFilterType;
    typedef itk::MultiResolutionPyramidImageFilter<SignedImageType, SignedImageType > MultiResolutionPyramidType;


    // Transform definitions
    typedef itk::MinimumMaximumImageCalculator< ProbabilityImageType > MinimumMaximumImageCalculatorType;
    typedef itk::IdentityTransform< double, 3 > IdentityTransformType;
    typedef itk::ScaleTransform< double, 3 > ScaleTransformType;
    typedef itk::VersorRigid3DTransform< double > RigidTransformType;
    typedef itk::AffineTransform< double, 3 > AffineTransformType;
    typedef itk::BSplineDeformableTransform< double, 3, 3 >     DeformableTransformType;
    typedef itk::CenteredTransformInitializer< RigidTransformType, ProbabilityImageType, ProbabilityImageType > TransformInitializerType;
    typedef DeformableTransformType::RegionType RegionType;
    typedef DeformableTransformType::SpacingType SpacingType;
    typedef DeformableTransformType::OriginType OriginType;
    typedef DeformableTransformType::ParametersType ParametersType;
    typedef DeformableTransformType::ImageType ParametersImageType;
    typedef itk::ResampleImageFilter<ParametersImageType,ParametersImageType> ResamplerType;
    typedef itk::BSplineResampleImageFunction<ParametersImageType,CoordinateRepType> FunctionType;
    typedef itk::BSplineDecompositionImageFilter<ParametersImageType,ParametersImageType> DecompositionType;
    typedef itk::ImageRegionIterator<ParametersImageType> Iterator;

    // Casting
    typedef itk::CastImageFilter< ProbabilityImageType, SignedImageType> IntensityToSignedCastType;

    // Optimizer
    typedef itk::VersorRigid3DTransformOptimizer VersorOptimizerType;
    typedef VersorOptimizerType::ScalesType VersorScalesType;
    typedef itk::RegularStepGradientDescentOptimizer OptimizerType;
    typedef OptimizerType::ScalesType OptimizerScalesType;

    // Interpolator
    typedef itk::LinearInterpolateImageFunction<SignedImageType,double > linInterpolatorType;
    typedef itk::NearestNeighborInterpolateImageFunction<MaskImageType,double> NNInterpolatorType;
    typedef itk::NearestNeighborInterpolateImageFunction<ResultsImageType,double> NNAnatomicInterpolatorType;
    typedef itk::BSplineInterpolateImageFunction<ProbabilityImageType,double> BSplineImageInterpolatorType;
    typedef itk::BSplineInterpolateImageFunction<ProbabilityImageType,double> BSplineAtlasInterpolatorType;
    typedef itk::BSplineInterpolateImageFunction<SignedImageType,double> BSplineInterpolatorType;


    // Metric definitions
    typedef itk::ImageToImageMetric<SignedImageType,SignedImageType> GenericMetricType;
    typedef itk::MutualInformationImageToImageMetric<SignedImageType,SignedImageType> MIMetricType;
    typedef itk::MattesMutualInformationImageToImageMetric<SignedImageType,SignedImageType > MattesMIMetricType;
    typedef itk::MutualInformationHistogramImageToImageMetric<SignedImageType,SignedImageType > MIHistogramMetricType;
    typedef itk::NormalizedMutualInformationHistogramImageToImageMetric<SignedImageType,SignedImageType > NMIMetricType;
    typedef itk::GradientDifferenceImageToImageMetric<SignedImageType,SignedImageType> GDMetricType;
    typedef itk::KullbackLeiblerCompareHistogramImageToImageMetric<SignedImageType, SignedImageType> KLHistogramMetricType;
    typedef itk::KappaStatisticImageToImageMetric<SignedImageType, SignedImageType> KappaMetricType;
    typedef itk::CorrelationCoefficientHistogramImageToImageMetric<SignedImageType, SignedImageType> CorrelationMetricType;
    typedef itk::NormalizedCorrelationImageToImageMetric<SignedImageType, SignedImageType> NormalizedCorrelationMetricType;
    typedef itk::MeanSquaresImageToImageMetric<SignedImageType, SignedImageType> MSMetricType;
    typedef itk::MeanSquaresHistogramImageToImageMetric<SignedImageType, SignedImageType> MSHistogramMetricType;
    typedef itk::MeanReciprocalSquareDifferenceImageToImageMetric<SignedImageType, SignedImageType> MSReciprocalMetricType;

    // Observers
    typedef RegistrationLevelUpdate<MultiResolutionRegistrationType> ObserverType;

    // PreProcessing
    typedef itk::HistogramMatchingImageFilter< SignedImageType, SignedImageType > MatchingFilterType;
    typedef itk::RecursiveGaussianImageFilter< SignedImageType, SignedImageType > GaussianFilterType;



















// definicions de tots els tipus globals
// EP! cal que les imatges fixes i mobils tinguin el mateix tipus de pixel! (sino falla la superclasse de imatges que no son fixes ni mobils)

  const    unsigned int    Dimension = 3;

  typedef  double PixelType; //aquesta es la que tenia posada l'exemple de registre rigid
  //typedef  unsigned char   PixelType; //aquesta es la que tenia posada l'exemple de registre flexible
  //typedef unsigned short PixelType; // aquesta es la que tenia per defecte el registre amb demons

  // definicions de pixels "interns" pel registre rigid amb multires i pel registre demons
  typedef   double     InternalPixelType;
  typedef itk::Image< InternalPixelType, Dimension > InternalImageType;

  // definicions tipus de imatges	
  typedef itk::Image< PixelType, Dimension >  FixedImageType;
  typedef itk::Image< PixelType, Dimension >  MovingImageType;

  // definicions tipus transformacions i relacionades

 // The AffineTransform is a linear transformation that maps lines into
 // lines. It can be used to represent translations, rotations, anisotropic
 // scaling, shearing or any combination of them. Details about the affine
 // transform can be seen in Section~\ref{sec:AffineTransform}.
  //typedef itk::AffineTransform< double, Dimension  >     AffineTransformType;

  // Rigid transform type
  //typedef itk::CenteredRigid2DTransform< double > RigidTransformType;


  //  One of the easiest ways of preparing a consistent set of parameters for
  //  the transform is to use the CenteredTransformInitializer. Once
  //  the transform is initialized, we can invoke its GetParameters()
  //  method to extract the array of parameters. Finally the array is passed to
  //  the registration method using its SetInitialTransformParameters() method.
 // typedef itk::CenteredTransformInitializer< AffineTransformType, FixedImageType, MovingImageType >  TransformInitializerType;

  typedef itk::IdentityTransform< double, Dimension > IdentityTransformType;

  typedef itk::TranslationTransform< double, Dimension >  translationTransformType;

  typedef translationTransformType::ParametersType translationParametersType;


  // definicions tipus del registre 
  typedef itk::RegularStepGradientDescentOptimizer       OptimizerType;
  typedef itk:: LinearInterpolateImageFunction< MovingImageType, double >    InterpolatorType;

  typedef itk::ImageRegistrationMethod< FixedImageType, MovingImageType >    RegistrationType;

  typedef OptimizerType::ScalesType       OptimizerScalesType;

  // definicions dels tipus de lectura
  typedef itk::ImageFileReader< itk::Image< PixelType, Dimension> > SuperImageReaderType;
  typedef itk::ImageFileReader< FixedImageType  > FixedImageReaderType;
  typedef itk::ImageFileReader< MovingImageType > MovingImageReaderType;

  // llegirem DICOM!
  typedef itk::GDCMImageIO           ImageIOType;

  // Define all possible metryc types
  typedef itk::MeanSquaresImageToImageMetric< FixedImageType, MovingImageType >    MetricType0;
  typedef itk::MattesMutualInformationImageToImageMetric< FixedImageType, MovingImageType >    MetricType1;
  //typedef itk::MutualInformationImageToImageMetric< FixedImageType, MovingImageType >    MetricType2;
  typedef itk::NormalizedMutualInformationHistogramImageToImageMetric< FixedImageType, MovingImageType >    MetricType2;


  // definicions de tipus pel filtratge
  typedef itk::ResampleImageFilter<FixedImageType,FixedImageType> FilterType;
  typedef itk::NearestNeighborInterpolateImageFunction< FixedImageType, double >  filterInterpolatorType;

  // definicions dels tipus que fem servir pel postproces de les imatges (básicament escriptura), els unsigned short es fan servir ja que les imatges d'Udiat, de 12 bits, donaven problemes
  typedef  unsigned short  OutputPixelType;


  typedef itk::Image< OutputPixelType, Dimension > OutputImageType;

  typedef itk::CastImageFilter< 
                        FixedImageType,
                        OutputImageType > CastFilterType;

  // tipus per a les transformacions,que sino la liem amb les imatges binaries.	
  typedef  double  OutputPixelTypeTransf; 
  //typedef  signed short  OutputPixelTypeTransf; 

  typedef itk::Image< OutputPixelTypeTransf, Dimension > OutputImageTypeTransf;

  typedef itk::CastImageFilter<FixedImageType,OutputImageTypeTransf > CastFilterTypeTransf;

  typedef itk::ImageFileWriter< OutputImageTypeTransf >  WriterTypeTransf;



  // cast filters relacionats amb el tipus intern d'imatge, pel registre amb demons	
  typedef itk::CastImageFilter< FixedImageType, 
                                InternalImageType > FixedImageCasterType;
  typedef itk::CastImageFilter< MovingImageType, 
                                InternalImageType > MovingImageCasterType;

  // els dos seguents son de la multiresolucio
  typedef itk::CastImageFilter< 
                        FixedImageType, InternalImageType > FixedCastFilterType;
  typedef itk::CastImageFilter< 
                        MovingImageType, InternalImageType > MovingCastFilterType;

         
  typedef itk::ImageFileWriter< OutputImageType >  WriterType;

  typedef itk::ResampleImageFilter< 
                            MovingImageType, 
                            FixedImageType >    ResampleFilterType;

   // Two definitions of the difference filter, the first is signed (medium grey level is the best) and the second is made with absolute value (black is best) 	
  //typedef itk::SubtractImageFilter< FixedImageType, FixedImageType, FixedImageType > DifferenceFilterType;
  typedef itk::AbsoluteValueDifferenceImageFilter< FixedImageType, FixedImageType, OutputImageType > DifferenceFilterType;

  typedef itk::RescaleIntensityImageFilter< FixedImageType, OutputImageType >   RescalerType;

  typedef itk::CheckerBoardImageFilter< FixedImageType > CheckerBoardFilterType;


 // Tipus propis del registre flexible
  const unsigned int SpaceDimension = Dimension;
  const unsigned int SplineOrder = 3;
  typedef double CoordinateRepType;

  typedef itk::BSplineDeformableTransform<
                            CoordinateRepType,
                            SpaceDimension,
                            SplineOrder >     BsplineTransformType;

  typedef BsplineTransformType::RegionType RegionType;

  typedef BsplineTransformType::SpacingType SpacingType;

  typedef BsplineTransformType::OriginType OriginType;

  typedef BsplineTransformType::ParametersType     ParametersType;

  typedef itk::SquaredDifferenceImageFilter< 
                                  FixedImageType, 
                                  FixedImageType, 
                                  OutputImageType > SquaredDifferenceFilterType;

  typedef itk::Vector< double, Dimension >  VectorType;
  typedef itk::Image< VectorType, Dimension >  DeformationFieldType;
  typedef itk::ImageRegionIterator< DeformationFieldType > FieldIterator;
  typedef itk::ImageFileWriter< DeformationFieldType >  FieldWriterType;


// Morphons typedefs
    //typedef unsigned short OutputMorphonsPixelType; // UDIAT IMAGES ARE 12 bit!
    typedef double                                           MorphonsPixelType;
    typedef double                                                     InternalMorphonsPixelType;

    typedef itk::Image < InternalMorphonsPixelType, Dimension >    MorphonsInternalImageType;
        //InternalImageType::Pointer CertaintyImage;
        //InternalImageType::Pointer InternalMovingImage;
    typedef itk::Vector< double, Dimension >                     VectorMorphonsPixelType;
    typedef itk::Image < VectorMorphonsPixelType, Dimension >     DeformationFieldType;
    typedef itk::Image< OutputPixelType, Dimension >      OutputImageType;    

    typedef itk::Image < MorphonsPixelType, Dimension >               MorphonsFixedImageType;
    typedef itk::Image < MorphonsPixelType, Dimension >               MorphonsMovingImageType;

    //typedef itk::GDCMImageIO           ImageIOType;

    typedef itk::ImageFileReader < MorphonsFixedImageType >        MorphonsFixedImageReaderType;
    typedef itk::ImageFileReader < MorphonsMovingImageType >      MorphonsMovingImageReaderType;

    typedef itk::CastImageFilter < MorphonsMovingImageType, MorphonsInternalImageType >         MorphonsMovingCasterType;

    typedef itk::CastImageFilter < MorphonsFixedImageType, MorphonsInternalImageType >          MorphonsFixedCasterType;



