
// funcio per mesurar distancies entre dues imatges, metric used: 0 MQ, 1 MI, 2NMI
double mesuraDistanciaDuesImatges(string im1, string im2, int metricUsed, bool useAvancedMethods=true)
{
  double ret;	
  int numberOfBins=256;
  float threshold = 1;

  bool erMMI =false, erRMS=false,erNHMMI=false;
	
  FixedImageReaderType::Pointer fixedReader  = FixedImageReaderType::New();
  MovingImageReaderType::Pointer movingReader = MovingImageReaderType::New();

  fixedReader->SetFileName(  im1 );
  movingReader->SetFileName( im2 );

  ImageIOType::Pointer gdcmImageIO1 = ImageIOType::New();
  ImageIOType::Pointer gdcmImageIO2 = ImageIOType::New();

  std::string stringAux=im1;
  //std::cout<<"mida del nom: "<<stringAux.size()<<" 3 Ultims caracters: "<<stringAux[stringAux.size()-3]<<stringAux[stringAux.size()-2]<<stringAux[stringAux.size()-1]<<std::endl; 
  bool formatDicom = ((stringAux[stringAux.size()-3]=='d')&&(stringAux[stringAux.size()-2]=='c')&&(stringAux[stringAux.size()-1]=='m'));
  if (formatDicom) 
  {
	//std::cout<<" El primer fitxer te extensio dcm! "<<std::endl;
	fixedReader->SetImageIO( gdcmImageIO1 );
  }
  else
  {
    //std::cout<<" El primer fitxer No te extensio dcm! "<<std::endl;
  }

  std::string stringAux2=im2;
  //std::cout<<"mida del nom: "<<stringAux.size()<<" 3 Ultims caracters: "<<stringAux[stringAux.size()-3]<<stringAux[stringAux.size()-2]<<stringAux[stringAux.size()-1]<<std::endl; 
  formatDicom = ((stringAux2[stringAux2.size()-3]=='d')&&(stringAux2[stringAux2.size()-2]=='c')&&(stringAux2[stringAux2.size()-1]=='m'));
  if (formatDicom) 
  {
	//std::cout<<" El segon fitxer te extensio dcm! "<<std::endl;
 	movingReader->SetImageIO( gdcmImageIO2 );
  }
  else
  {
    //std::cout<<" El segon fitxer No te extensio dcm! "<<std::endl;
  }


  try
    {
    fixedReader->Update();
    movingReader->Update();
    }
  catch( itk::ExceptionObject & excep )
    {
    std::cerr << "Exception catched !" << std::endl;
    std::cerr << excep << std::endl;
	exit(-1);
    }

	//std::cout << fixedReader->GetOutput()->GetSpacing() << std::endl;
	//std::cout << movingReader->GetOutput()->GetSpacing() << std::endl;

	FixedImageType::SpacingType spacing;
	spacing = movingReader->GetOutput()->GetSpacing();
	fixedReader->GetOutput()->SetSpacing(spacing);


  //filterInterpolatorType::Pointer interpolator = filterInterpolatorType::New();
  InterpolatorType::Pointer interpolator = InterpolatorType::New();

  translationTransformType::Pointer transform = translationTransformType::New();

  translationParametersType displacement( transform->GetNumberOfParameters() );
  displacement.Fill(  0.0  );


   FixedImageType::ConstPointer fixedImage  = fixedReader->GetOutput();
   MovingImageType::ConstPointer movingImage = movingReader->GetOutput();

  FixedImageType::RegionType fixedRegion = fixedImage->GetBufferedRegion();
  MovingImageType::RegionType movingRegion = fixedImage->GetBufferedRegion();

  int numberOfPixelsFixed = fixedRegion.GetNumberOfPixels();
  int numberOfPixelsMoving = movingRegion.GetNumberOfPixels();
  int numberOfPixels;

  if(numberOfPixelsFixed>=numberOfPixelsMoving){
	  numberOfPixels = numberOfPixelsMoving;
  }
  else{
	  numberOfPixels = numberOfPixelsFixed;
  }

//std::cout<<"Numero de pixels per aqui dintre: "<<numberOfPixelsFixed<<" "<<numberOfPixelsMoving<<endl;

  const unsigned int numberOfSamples = static_cast<unsigned int>( numberOfPixels * 100.0 / 100.0 );
//const unsigned int numberOfSamples = 5000;

    double valueMS;
    double valueMMI;
    double valueNHMMI;	

    MetricType0::Pointer metricMS = MetricType0::New();
    MetricType1::Pointer metricMMI = MetricType1::New();
    MetricType2::Pointer metricNHMMI = MetricType2::New();

  //intensity thresholds
  typedef itk::ImageFileReader< ProbabilityImageType > ProbabilityReaderType;
  

  ProbabilityReaderType::Pointer freader = ProbabilityReaderType::New();
  ProbabilityImageType::Pointer fimage = NULL;

    if (im1.compare("")!=0) {
        freader->SetFileName( im1 );
        // Reading the image.
        try {
            freader->Update();
            fimage = freader->GetOutput();
        }
        catch (itk::ExceptionObject & e) {
            std::cerr << "exception in file reader " << std::endl;
            std::cerr << e.GetDescription() << std::endl;
            std::cerr << e.GetLocation() << std::endl;
        }
    }
 
  MinimumMaximumImageCalculatorType::Pointer minmax;
  minmax = MinimumMaximumImageCalculatorType::New();	
  minmax->SetImage(fimage);
  minmax->Compute();

 switch(metricUsed)
  {
	case 0:	
	  /* MEAN SQUARE METRIC */


	  metricMS->SetInterpolator( interpolator );
	  metricMS->SetTransform( transform );
	  
	  transform->SetIdentity();

	  metricMS->SetFixedImage(  fixedImage  );
	  metricMS->SetMovingImage( movingImage );

	  metricMS->SetFixedImageRegion(  fixedImage->GetBufferedRegion()  );

	  metricMS->SetFixedImageSamplesIntensityThreshold(minmax->GetMaximum()*0.05);
	
	  if(useAvancedMethods)
	  {
		metricMS->SetUseFixedImageSamplesIntensityThreshold(true);
		metricMS->SetFixedImageSamplesIntensityThreshold(threshold);
	  }

	  try
	    {
	    metricMS->Initialize();
	    }
	  catch( itk::ExceptionObject & excep )
	    {
	    std::cerr << "Exception catched !" << std::endl;
	    std::cerr << excep << std::endl;
	    erRMS=true;
	    }

		if (!erRMS){  
			valueMS = metricMS->GetValue( displacement );
		}
		else{
			valueMS = 7777;
		}

	  //std::cout << im1 << " vs " << im2 << " \n";
	  //std::cout << "MS = " << valueMS << std::endl;
	  ret=valueMS;	
   	  break;


	case 1:	

	  /* MATES MUTUAL INFORMATION METRIC */

	  metricMMI->SetInterpolator( interpolator );
	  metricMMI->SetTransform( transform );
	  
	  transform->SetIdentity();

	  metricMMI->SetFixedImage(  fixedImage  );
	  metricMMI->SetMovingImage( movingImage );

	  metricMMI->SetFixedImageRegion(  fixedImage->GetBufferedRegion()  );

	  metricMMI->SetNumberOfSpatialSamples(numberOfSamples);
	  metricMMI->SetNumberOfHistogramBins( numberOfBins );

	  metricMMI->SetFixedImageSamplesIntensityThreshold(minmax->GetMaximum()*0.05);

	  if(useAvancedMethods)
	  {
		metricMMI->SetUseFixedImageSamplesIntensityThreshold(true);
		metricMMI->SetFixedImageSamplesIntensityThreshold(threshold);
	  }

		//std::cout <<	metricMMI->GetFixedImageSamplesIntensityThreshold() << std::endl;

	  try
	    {
	    metricMMI->Initialize();
	    }
	  catch( itk::ExceptionObject & excep )
	    {
	    std::cerr << "Exception catched !" << std::endl;
	    std::cerr << excep << std::endl;
	    erMMI=true;
	    }
		if (!erMMI){  
			valueMMI = metricMMI->GetValue( displacement );
		}
		else{
			valueMMI = 7777;
		}

	  //std::cout << im1 << " vs " << im2 << " \n";
	  //std::cout << "MMI = " << valueMMI << std::endl;
	 // std::cout << "mesurar distancies entre imatge, cambio el signe de MMI"<< std::endl;
	  ret=-valueMMI;	
	break;
	case 2:
	  /* NORMALISED HISTOGRAM MUTUAL INFORMATION METRIC */

	  metricNHMMI->SetInterpolator( interpolator );
	  metricNHMMI->SetTransform( transform );
	  
	  transform->SetIdentity();

	  metricNHMMI->SetFixedImage(  fixedImage  );
	  metricNHMMI->SetMovingImage( movingImage );

	  metricNHMMI->SetFixedImageRegion(  fixedImage->GetBufferedRegion()  );

	  metricNHMMI->SetNumberOfSpatialSamples(numberOfSamples);
	  //metricNHMMI->SetNumberOfHistogramBins( numberOfBins );
	  metricNHMMI->SetFixedImageSamplesIntensityThreshold(minmax->GetMaximum()*0.05);

	  if(useAvancedMethods)
	  {
		metricNHMMI->SetUseFixedImageSamplesIntensityThreshold(true);
		metricNHMMI->SetFixedImageSamplesIntensityThreshold(threshold);
	  }


	  try
	    {
	    metricNHMMI->Initialize();
	    }
	  catch( itk::ExceptionObject & excep )
	    {
	    std::cerr << "Exception catched !" << std::endl;
	    std::cerr << excep << std::endl;
	    erNHMMI=true;
	    }
		if (!erNHMMI){  
			valueNHMMI = metricNHMMI->GetValue( displacement );
		}
		else{
			valueNHMMI = 7777;
		}

	  ret=valueNHMMI;	

	break;
	default:
        std::cerr << "Incorrect Metric Specificattion " << std::endl;
        std::cerr <<"Value: "<< metricUsed << std::endl;
	exit(-1);
}
  return ret;



}



// Calcular diferencies abans i despres del registre
/*void calcularDiferencies(char *argv[], int argc, int metricUsed, ResampleFilterType::Pointer resampler, FixedImageReaderType::Pointer  fixedImageReader )
{
  DifferenceFilterType::Pointer difference = DifferenceFilterType::New();

  difference->SetInput1( fixedImageReader->GetOutput() );
  difference->SetInput2( resampler->GetOutput() );

  WriterType::Pointer writer2 = WriterType::New();
  
  RescalerType::Pointer intensityRescaler = RescalerType::New();

  intensityRescaler->SetInput( difference->GetOutput() );
  intensityRescaler->SetOutputMinimum( 0 );
  intensityRescaler->SetOutputMaximum( 255 );
  
  writer2->SetInput( intensityRescaler->GetOutput() );  
  resampler->SetDefaultPixelValue( 1 );
 
switch(metricUsed)
   {
 	case 0:	
 	// minims quadrats
        writer2->SetFileName( "./diffAfiAfterMQ.dcm");
  	break;
	case 1:	
	// MI mattes
        writer2->SetFileName( "./diffAfiAfterMI.dcm");
 	break;
	case 2:	
	// MI viola-wells
        writer2->SetFileName( "./diffAfiAfterVWMI.dcm");
 	break;
  }
    writer2->Update();

  IdentityTransformType::Pointer identity = IdentityTransformType::New();

    resampler->SetTransform( identity );

switch(metricUsed)
   {
 	case 0:	
 	// minims quadrats
        writer2->SetFileName( "./diffAfiBeforeMQ.dcm");
  	break;
	case 1:	
	// MI mattes
        writer2->SetFileName( "./diffAfiBeforeMI.dcm");
 	break;
	case 2:	
	// MI viola-wells
        writer2->SetFileName( "./diffAfiBeforeVWMI.dcm");
 	break;
  }

    writer2->Update();

}

// genera les imatges checkerboard 
void computeCheckerboardPatterns(int metricUsed, AffineTransformType::Pointer finalTransform, FixedImageType::Pointer fixedImage,  WriterType::Pointer writer, ResampleFilterType::Pointer resampler, CastFilterType::Pointer  caster)
{

 // Generate checkerboards before and after registration
  CheckerBoardFilterType::Pointer checker = CheckerBoardFilterType::New();

  checker->SetInput1( fixedImage );
  checker->SetInput2( resampler->GetOutput() );

  // fixem la mida del checkerboard pattern
  unsigned int *a = new unsigned int[2];
  a[0]=8;
  a[1]=8;

   checker->SetCheckerPattern(a); 

  caster->SetInput( checker->GetOutput() );
  writer->SetInput( caster->GetOutput()   );
  
  // Before registration
  AffineTransformType::Pointer identityTransform = AffineTransformType::New();
  identityTransform->SetIdentity();

   resampler->SetTransform( identityTransform );

 switch(metricUsed)
  {
	case 0:	
	// minims quadrats
        writer->SetFileName( "./checkerAfiBeforeMQ.dcm" );
 	break;
	case 1:	
	// MI mattes
        writer->SetFileName( "./checkerAfiBeforeMAttesMI.dcm" );
 	break;
	case 2:	
	// MI viola-wells
        writer->SetFileName( "./checkerAfiBeforeVWMI.dcm" );
 	break;
 }
   writer->Update();
 
  // After registration
  resampler->SetTransform( finalTransform );

switch(metricUsed)
  {
	case 0:	
	// minims quadrats
        writer->SetFileName( "./checkerAfiAfterMQ.dcm" );
 	break;
	case 1:	
	// MI mattes
        writer->SetFileName( "./checkerAfiAfterMattesMI.dcm" );
 	break;
	case 2:	
	// MI viola-wells
        writer->SetFileName( "./checkerAfiAfterVWMI.dcm" );
 	break;
 }
 

 writer->Update();


}*/


