#!/bin/bash

# exemple d'execució: 

#definim parametres:
sourceDir=$1
fixed=$2
moving=$3 
outputDir=$4
mrLevels=$5
iterations=$6
regType=$7
lesionsBasal=$8
lesions12M=$9

iterations=$(( iterations / mrLevels ))

# Decide wheteher this is a temporal register
if [[ $regType = ATLAS || $regType = ATLASH ]]
then
	temporalRegister=false
else
	temporalRegister=true
fi

echo "********************************************************************************************************** " 
echo "* Testadort demons MR: Parametres de la prova:"
echo "* Imatge Fixa: $fixed"
echo "* Imatge Mobil: $moving"
echo "* Prefix directori sortida: $outputDir"
echo "* iteracions: $iterations "
echo "* nivells: $mrLevels  "
echo "********************************************************************************************************** " 

echo " " 
echo "                        **************************************************************************************************** " 
echo "                                 PROVANT Registre demons "		  
echo " executo: $sourceDir/demonsMR3D $fixed $moving ./outputDemonsMR.nii ./deformationField.mha $iterations $mrLevels > sDemonsMR$outputDir.txt			
	 "
echo "                        **************************************************************************************************** " 


$sourceDir/demonsMR3D $fixed $moving ./outputDemonsMR.nii ./deformationField.mha $iterations $mrLevels > sDemonsMR$outputDir.txt	

#compute moved ground truth
if ( "$temporalRegister" -eq true ) ; then
$sourceDir/deformableWarp $lesions12M deformationField.mha deformedLesions.nii
fi

# compute difference images
$sourceDir/imageDifference $fixed outputDemonsMR.nii diffDemonsMRAfter.nii
if ( "$temporalRegister" -eq true ) ; then
$sourceDir/imageDifference $fixed $moving diffDemonsMRBefore.nii
fi

#prepare output
mkdir filesDemonsMR\_$outputDir

#move difference images
mv diffDemonsMRAfter.nii filesDemonsMR\_$outputDir
mv diffDemonsMRBefore.nii filesDemonsMR\_$outputDir
 
#move nii files
mv outputDemonsMR.nii filesDemonsMR\_$outputDir

#move lesion information
if ( "$temporalRegister" -eq true ) ; then
cp $lesionsBasal ./lesionsBasal.nii
cp $lesions12M ./lesions12M.nii

mv lesionsBasal.nii filesDemonsMR\_$outputDir
mv lesions12M.nii filesDemonsMR\_$outputDir
mv deformedLesions.nii filesDemonsMR\_$outputDir 
fi

#move the rest
mv sDemonsMR$outputDir.txt filesDemonsMR\_$outputDir
mv deformationField.mha filesDemonsMR\_$outputDir


