#!/bin/bash

# exemple d'execució: 

#definim parametres:
sourceDir=$1
fixed=$2
moving=$3 
outputDir=$4
iterations=$5
mRLevels=$6
regType=$7
lesionsBasal=$8
lesions12M=$9

#iterations divided 25 25 50
iterationsDem=$(( iterations /2 ))
iterationsDem=$(( iterationsDem / (mRLevels) ))

iterationsRigAfi=$(( iterations /4 ))
iterationsRigAfi=$(( iterationsRigAfi / (mRLevels) ))

# Decide wheteher this is a temporal register
if [[ $regType = ATLAS || $regType = ATLASH ]]
then
	temporalRegister=false
else
	temporalRegister=true
fi

echo "********************************************************************************************************** " 
echo "* Testadort Rig Afi demons MR: Parametres de la prova:"
echo "* Imatge Fixa: $fixed"
echo "* Imatge Mobil: $moving"
echo "* Prefix directori sortida: $outputDir"
echo "* iteracions 25 25 50: $iterationsRigAfi $iterationsDem "
echo "* nivells: $mRLevels  "
echo "********************************************************************************************************** " 

echo "                        **************************************************************************************************** " 
echo "                                 Primera part, registre rigid afi "		  
echo "********************************************************************************************************** " 

$sourceDir/BrainReg 2 $fixed $moving $mRLevels $iterationsRigAfi $mRLevels $iterationsRigAfi > sRigAfiDemonsMR$outputDir.txt


echo " " 
echo "                        **************************************************************************************************** " 
echo "                                 PROVANT Registre demons "		  
echo " executo:  $sourceDir/demonsMR3D $fixed outputRigAfi.nii ./outputRigAfiDemonsMR.nii ./deformationField.mha $iterationsDem $mRLevels >> sRigAfiDemonsMR$outputDir.txt	 "
echo "                        **************************************************************************************************** " 


$sourceDir/demonsMR3D $fixed outputRigAfi.nii ./outputRigAfiDemonsMR.nii ./deformationField.mha $iterationsDem $mRLevels >> sRigAfiDemonsMR$outputDir.txt	

#compute moved ground truth
if ( "$temporalRegister" -eq true ) ; then
#$sourceDir/transformacioRigid rigidTransform.txt $lesionsBasal $lesions12M intermediate1.nii
#$sourceDir/transformacioAfi affineTransform.txt $lesionsBasal intermediate1.nii intermediate2.nii
$sourceDir/transformacioAfi affineTransform.txt $lesionsBasal $lesions12M intermediate2.nii
$sourceDir/deformableWarp intermediate2.nii deformationField.mha deformedLesions.nii
fi

# compute difference images
$sourceDir/imageDifference $fixed outputRigAfiDemonsMR.nii diffRigAfiDemonsMRAfter.nii
if ( "$temporalRegister" -eq true ) ; then
$sourceDir/imageDifference $fixed $moving diffRigAfiDemonsMRBefore.nii
fi

#prepare output
mkdir filesRigAfiDemonsMR\_$outputDir

#move difference images
mv diffRigAfiDemonsMRAfter.nii filesRigAfiDemonsMR\_$outputDir
if ( "$temporalRegister" -eq true ) ; then
mv diffRigAfiDemonsMRBefore.nii filesRigAfiDemonsMR\_$outputDir
fi
 
#move nii files
mv outputRigAfiDemonsMR.nii filesRigAfiDemonsMR\_$outputDir
mv outputRigAfi.nii filesRigAfiDemonsMR\_$outputDir

#move rigid and affine transformations
mv affineTransform.txt filesRigAfiDemonsMR\_$outputDir
mv rigidTransform.txt filesRigAfiDemonsMR\_$outputDir

#move lesion information
if ( "$temporalRegister" -eq true ) ; then
cp $lesionsBasal ./lesionsBasal.nii
cp $lesions12M ./lesions12M.nii

mv lesionsBasal.nii filesRigAfiDemonsMR\_$outputDir
mv lesions12M.nii filesRigAfiDemonsMR\_$outputDir
mv deformedLesions.nii filesRigAfiDemonsMR\_$outputDir
mv intermediate*.nii filesRigAfiDemonsMR\_$outputDir
fi

#move the rest
mv sRigAfiDemonsMR$outputDir.txt filesRigAfiDemonsMR\_$outputDir
mv deformationField.mha filesRigAfiDemonsMR\_$outputDir


