#!/bin/bash

#defineparametres:
sourceDir=$1
fixed=$2
moving=$3
outputDir=$4
mrLevels=$5 #from 0 to mrLevels-1
iterations=$6
regType=$7
lesionsBasal=$8
lesions12M=$9

#we divide iterations equally between rigid and affine
iterationsBsp=$(( iterations /2 ))
iterationsBsp=$(( iterationsBsp / (mrLevels +1) ))

iterations=$(( iterations /4 ))
iterations=$(( iterations / (mrLevels +1) ))

# Decide wheteher this is a temporal register
if [[ $regType = ATLAS || $regType = ATLASH ]]
then
	temporalRegister=false
else
	temporalRegister=true
fi

echo "********************************************************************************************************** " 
echo "* Testadort Rigid + Afi + Bsplines: Parametres de la prova:"
echo "* Imatge Fixa: $fixed"
echo "* Imatge Mobil: $moving"
echo "* Prefix directori sortida: $outputDir"
echo "* mr levels Rig $mrLevels "
echo "* iteracions Rig $iterations "
echo "* mr levels Afi $mrLevels "
echo "* iteracions Afi $iterations "
echo "* mr levels Bsp $mrLevels "
echo "* iteracions Bsp $iterationsBsp "
echo "********************************************************************************************************** " 

# Versor Rigid + Afí + Multi Bsplines
# BrainReg 3 <fixed> <moving> <nivells rigid> <iteracions rigid> <nivells afí> <iteracions afí> <nodes per dimensió del grid inicial> <nivells Bspline> <iteracions Bspline>
$sourceDir/BrainReg 3 $fixed $moving $mrLevels $iterations $mrLevels $iterations 4 $mrLevels $iterationsBsp > sRigAfiBsp$outputDir.txt

#potser cal discutir els parametres aquests inicials i tal??? numero de nodes per grid i nivells de MR i iteracions per nivell

#potser caldria incorporar distancies en l'optimitzador aqui? en Mariano ho te preparat per enxuflarhi les distancies que calgui. Segurament tambe caldria un metode apart per medir distancies despres

# compute difference images
$sourceDir/imageDifference $fixed outputRigAfiBsp.nii diffRigAfiBspAfter.nii
if ( "$temporalRegister" -eq true ) ; then
$sourceDir/imageDifference $fixed $moving diffRigAfiBspBefore.nii
fi

#compute moved ground truth
if ( "$temporalRegister" -eq true ) ; then
#$sourceDir/transformacioRigid rigidTransform.txt $lesionsBasal $lesions12M intermediate1.nii
#$sourceDir/transformacioAfi affineTransform.txt $lesionsBasal intermediate1.nii intermediate2.nii
#$sourceDir/transformacioAfi affineTransform.txt $lesionsBasal $lesions12M intermediate2.nii
#$sourceDir/transformacioFlexible bsplineTransform.txt $lesionsBasal intermediate2.nii deformedLesions.nii
$sourceDir/transformacioFlexible bsplineTransform.txt $lesionsBasal $lesions12M deformedLesions.nii
fi

#prepare output
mkdir filesRigAfiBsp\_$outputDir

#move difference images
mv diffRigAfiBspAfter.nii filesRigAfiBsp\_$outputDir
mv diffRigAfiBspBefore.nii filesRigAfiBsp\_$outputDir

#move nii files
mv outputRigAfiBsp.nii filesRigAfiBsp\_$outputDir

#move rigid and affine transformations
mv affineTransform.txt filesRigAfiBsp\_$outputDir
mv rigidTransform.txt filesRigAfiBsp\_$outputDir
mv bsplineTransform.txt filesRigAfiBsp\_$outputDir

#move lesion information
if ( "$temporalRegister" -eq true ) ; then
cp $lesionsBasal ./lesionsBasal.nii
cp $lesions12M ./lesions12M.nii

mv lesionsBasal.nii filesRigAfiBsp\_$outputDir
mv lesions12M.nii filesRigAfiBsp\_$outputDir
mv deformedLesions.nii filesRigAfiBsp\_$outputDir 
mv intermediate*.nii filesRigAfiBsp\_$outputDir
fi

#move the rest
mv sRigAfiBsp$outputDir.txt filesRigAfiBsp\_$outputDir


