#!/bin/bash

#defineparametres:
sourceDir=$1
fixed=$2
moving=$3
outputDir=$4
mrLevels=$5 #from 0 to mrLevels-1
iterations=$6
regType=$7
lesionsBasal=$8
lesions12M=$9

#we divide iterations equally between rigid and affine
iterations=$(( iterations /2 ))
iterations=$(( iterations / (mrLevels +1) ))

# Decide wheteher this is a temporal register
if [[ $regType = ATLAS || $regType = ATLASH ]]
then
	temporalRegister=false
else
	temporalRegister=true
fi

echo "********************************************************************************************************** " 
echo "* Testadort Rigid + Afi: Parametres de la prova:"
echo "* Imatge Fixa: $fixed"
echo "* Imatge Mobil: $moving"
echo "* Prefix directori sortida: $outputDir"
echo "* mr levels Rig $mrLevels "
echo "* iteracions Rig $iterations "
echo "* mr levels Afi $mrLevels "
echo "* iteracions Afi $iterations "
echo "********************************************************************************************************** " 

# BrainReg 2 <fixed> <moving> <nivells rigid> <iteracions rigid> <nivells afí> <iteracions afí>
$sourceDir/BrainReg 2 $fixed $moving $mrLevels $iterations $mrLevels $iterations > sRigAfi$outputDir.txt

#compute moved ground truth
if ( "$temporalRegister" -eq true ) ; then
#$sourceDir/transformacioRigid rigidTransform.txt $lesionsBasal $lesions12M intermediate.nii
#$sourceDir/transformacioAfi affineTransform.txt $lesionsBasal intermediate.nii deformedLesions.nii
$sourceDir/transformacioAfi affineTransform.txt $lesionsBasal $lesions12M deformedLesions.nii
fi

# compute difference images
$sourceDir/imageDifference $fixed outputRigAfi.nii diffRigAfiAfter.nii
if ( "$temporalRegister" -eq true ) ; then
$sourceDir/imageDifference $fixed $moving diffRigAfiBefore.nii
fi

#prepare output
mkdir filesRigAfi\_$outputDir

#move difference images
mv diffRigAfiAfter.nii filesRigAfi\_$outputDir
if ( "$temporalRegister" -eq true ) ; then
mv diffRigAfiBefore.nii filesRigAfi\_$outputDir
fi

#move nii files
mv outputRigAfi.nii filesRigAfi\_$outputDir

#move rigid and affine transformations
mv affineTransform.txt filesRigAfi\_$outputDir
mv rigidTransform.txt filesRigAfi\_$outputDir

#move lesion information
if ( "$temporalRegister" -eq true ) ; then
cp $lesionsBasal ./lesionsBasal.nii
cp $lesions12M ./lesions12M.nii

mv lesionsBasal.nii filesRigAfi\_$outputDir
mv lesions12M.nii filesRigAfi\_$outputDir
mv deformedLesions.nii filesRigAfi\_$outputDir 
mv intermediate*.nii filesRigAfi\_$outputDir
fi

#move the rest
mv sRigAfi$outputDir.txt filesRigAfi\_$outputDir


