#!/bin/bash

#defineparametres:
sourceDir=$1
fixed=$2
moving=$3
outputDir=$4
mrLevels=$5 #from 0 to mrLevels-1
iterations=$6
regType=$7
lesionsBasal=$8
lesions12M=$9

iterations=$(( iterations / (mrLevels +1) ))

# Decide wheteher this is a temporal register
if [[ $regType = ATLAS || $regType = ATLASH ]]
then
	temporalRegister=false
else
	temporalRegister=true
fi

echo "********************************************************************************************************** " 
echo "* Testadort Rigid: Parametres de la prova:"
echo "* Imatge Fixa: $fixed"
echo "* Imatge Mobil: $moving"
echo "* Prefix directori sortida: $outputDir"
echo "* mr levels $mrLevels "
echo "* iteracions $iterations "
echo "********************************************************************************************************** " 

# BrainReg 1 <fixed> <moving> <nivells rigid> <iteracions rigid>
$sourceDir/BrainReg 1 $fixed $moving $mrLevels $iterations > sRigid$outputDir.txt

#compute difference images
$sourceDir/imageDifference $fixed outputRigid.nii diffRigidAfter.nii
if ( "$temporalRegister" -eq true ) ; then
$sourceDir/imageDifference $fixed $moving diffRigidBefore.nii
fi

#compute moved ground 
if ( "$temporalRegister" -eq true ) ; then
	$sourceDir/transformacioRigid rigidTransform.txt $lesionsBasal $lesions12M deformedLesions.nii
fi

#prepare output
mkdir filesRigid\_$outputDir

#move difference files
mv diffRigidAfter.nii filesRigid\_$outputDir
if ( "$temporalRegister" -eq true ) ; then
mv diffRigidBefore.nii filesRigid\_$outputDir
fi

#move rigid transformation
mv rigidTransform.txt filesRigid\_$outputDir

#move nii files
mv outputRigid.nii filesRigid\_$outputDir

#move lesion information
if ( "$temporalRegister" -eq true ) ; then
cp $lesionsBasal ./lesionsBasal.nii
cp $lesions12M ./lesions12M.nii
mv lesionsBasal.nii filesRigid\_$outputDir
mv lesions12M.nii filesRigid\_$outputDir
mv deformedLesions.nii filesRigid\_$outputDir 
fi

#move the rest
mv sRigid$outputDir.txt filesRigid\_$outputDir

