#include "./src/definicionsTipus.h"
#include "./src/transformation.cxx"

int main( int argc, char *argv[] )
{
  if( argc < 2 ){
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << "   1: transformFile  2: fixedImageFile 3: movingImageFile 4: resultImageFile" << std::endl;    
    exit(-1);
    }
    
    //std::cerr << "Llegim trasformacio " << argv[1] << std::endl;
    
    AffineTransformType::Pointer transform = readTransformAffine(argv[1]);
      
    //std::cerr << "Tranformacio: " << std::endl;
    //std::cerr << transform << std::endl;
    
    //std::cerr << "Llegim imtage a trasformar " << argv[2] << std::endl;
    
    FixedImageType::Pointer fixedImage = FixedImageType::New();
    MovingImageType::Pointer movingImage = MovingImageType::New();    
    fixedImage=readFixedImage(argv[2]);
    movingImage=readMovingImage(argv[3]);
    
    //std::cerr << "Imatge: " << std::endl;
    //std::cerr << movingImageReader << std::endl;
    
    //std::cerr << "Apliquem transformacio " << std::endl;
            
    OutputImageTypeTransf::Pointer  result = OutputImageTypeTransf::New();    
    result=applyTransformAffine(fixedImage,movingImage,transform);  
    
    //std::cerr << "Imatge trasformada: " << std::endl;
    //std::cerr << result << std::endl;
    
    writeImage(result,argv[4]);
}


